subroutine ccm_check_sizes(routine,test1,test2,test3,root,passed)
	use ccm_numz, only :ccm_testing,err_str1,err_str2,myid,numnodes
	use ccm_bcast_mod
	use ccm_allreduce_mod
	use ccm_alltoall_mod
	use ccm_scatter_mod
	use ccm_gather_mod
	implicit none
	character(len=*) :: routine
	integer :: test1(:),test2(:),test3(:)
	integer :: root
	logical :: passed
	logical :: tmp
	integer,allocatable :: tosend(:),toget(:)
	integer :: old_test,dummy,i,dummy4(8)
	save tosend,toget
	if(.not.allocated(tosend))allocate(tosend(0:numnodes-1),toget(0:numnodes-1))
	call ccm_testing(get_test=old_test,set_test=0)
	tmp=.true.
	select case (routine)
		case ("bcast")
			tosend=test1(1)
			call ccm_alltoall(tosend,toget)
			passed=.true.
            do i=0,numnodes-1
            	if(toget(i).ne.test1(1))then
            		passed=.false.
            		exit
            	endif
            enddo
            if(.not. passed)then
            	write(err_str1,"(""size of input / output array "",i8)")test1(1)
				write(err_str2,"(""needs to be the same on all processors"")")
			endif
		case ("gather")
			dummy=test2(1)
			call ccm_bcast(dummy,root=root)
			if(dummy .ne. test1(1))tmp=.false.
			call ccm_allreduce(tmp,passed,"and")
			if(.not. passed)then
				if(myid .eq. root)then
						write(err_str1,*)"output array size/processor: ",dummy
					else
						write(err_str1,*)" "
				endif
					write(err_str2,*)"input array size: ",test1(1)
			endif
		case ("scatter")
			dummy=test2(1)
			call ccm_bcast(dummy,root=root)
			if(dummy .ne. test1(1))tmp=.false.
			call ccm_allreduce(tmp,passed,"and")
			if(.not. passed)then
				if(myid .eq. root)then
						write(err_str1,*)"input array size/processor: ",dummy
					else
						write(err_str1,*)" "
				endif
					write(err_str2,*)"output array size: ",test1(1)
			endif
		case ("gatherv")
		! test2(1)=size(xin)
		! test2(2)=size(xout)
		! test2(3)=size(to_get)
		! test2(4)=size(offset)
		! test1=to_send
			if(myid .eq. root)then
				i=0
				if(test2(3) .ne. numnodes)then !to_get wrong size
					tmp=.false.
					tosend=-1
					i=1
				else
					tosend(0:numnodes-1)=test1(1:numnodes)
				endif
				if(tmp)then
					if(sum(tosend) .ne. test2(2))then
						i=2
						tmp=.false. ! out wrong size
					endif
				endif
				if(tmp)then
					if(test2(4) .ne. numnodes)then
						i=3
						tmp=.false.    ! offset wrong size
					endif
				endif
			endif
			call ccm_scatter(tosend,dummy,root=root)
			if(dummy .ne. test2(1))tmp=.false.
			call ccm_allreduce(tmp,passed,"and")
			if(.not. passed)then
				if(myid .eq. root)then
					if(i .eq. 0)write(err_str1,120)
			120	format("mismatch between to_get and size of input array")
					if(i .eq. 1)write(err_str1,121)test2(3)
			121	format("size of to_get is wrong, to_get size=",i8)
					if(i .eq. 2)write(err_str1,122)
			122	format("mismatch between to_get and size of output array")
					if(i .eq. 3)write(err_str1,123)test2(4)
			123	format("size of offset is wrong, offset size=",i8)
			    write(err_str2,"(""expecting to send and get "",2i8)")test2(1),test2(2)
				else
					write(err_str1,*)" "
				    write(err_str2,"(""expecting to send"",i8)")test2(1)
				endif
			endif
		case ("scatterv")
		! test2(1)=size(xin)
		! test2(2)=size(xout)
		! test2(3)=size(to_send)
		! test2(4)=size(offset)
		! test1=to_send
			if(myid .eq. root)then
				i=0
				if(test2(3) .ne. numnodes)then !to_send wrong size
					tmp=.false.
					tosend=-1
					i=1
				else
					tosend(0:numnodes-1)=test1(1:numnodes)
				endif
				if(tmp)then
					if(sum(tosend) .ne. test2(1))then
						i=2
						tmp=.false. ! xin wrong size
					endif
				endif
				if(tmp)then
					if(test2(4) .ne. numnodes)then
						i=3
						tmp=.false.    ! offset wrong size
					endif
				endif
			endif
			call ccm_scatter(tosend,dummy,root=root)
			if(dummy .ne. test2(2))tmp=.false.
			call ccm_allreduce(tmp,passed,"and")
			if(.not. passed)then
				if(myid .eq. root)then
					if(i .eq. 0)write(err_str1,20)
			20	format("mismatch between to_send and size of output array")
					if(i .eq. 1)write(err_str1,21)test2(3)
			21	format("size of to_send is wrong, to_send size=",i8)
					if(i .eq. 2)write(err_str1,22)
			22	format("mismatch between to_send and size of input array")
					if(i .eq. 3)write(err_str1,23)test2(4)
			23	format("size of offset is wrong, offset size=",i8)
				    write(err_str2,"(""expecting to send and get "",2i8)")test2(2),test2(2)
				else
					write(err_str1,*)" "
				    write(err_str2,"(""expecting to get"",i8)")test2(2)
				endif
			endif
		case ("alltoall")
			dummy=test2(2)
			call ccm_bcast(dummy)
			if(dummy*numnodes .ne. test1(1))tmp=.false.
			if(dummy*numnodes .ne. test2(1))tmp=.false.
			call ccm_allreduce(tmp,passed,"and")
			if(.not. passed)then
			write(err_str1,"(""size of input and output arrays "",2i8)")test1(1),test2(1)
			if(mod(test1(1),numnodes) .ne. 0 .or. mod(test2(1),numnodes) .ne. 0)then
			write(err_str2,"(""need to be = and multiple of number of tasks : "",i4)")numnodes
			else
			write(err_str2,"(""need to be equal"")")
			endif
			endif
		case ("alltoallv")
			tmp=.true.
			!check for match of to_send and to_get arrays between processors
			if(test3(1) .eq. numnodes .and. test3(2) .eq. numnodes)then
				tosend(0:numnodes-1)=test1(1:numnodes)
			else
				tosend=-1
				tmp=.false.
				write(err_str1,*)"to_send and/or to_get array size is wrong"
            	write(err_str2,1)test3(1),test3(2)
          1 format("size(to_send)= ",i8," size(to_get)= ",i8)
			endif
            if(tmp)then
            	if(test3(3) .ne. numnodes)then
            		write(err_str1,3)test3(3)
          3 format("pid ",i8," get_off array wrong size ",i8)
          			write(err_str2,*)"should be ",numnodes
            		tmp=.false.
            	endif
            endif
            if(tmp)then
            	if(test3(4) .ne. numnodes)then
            		write(err_str1,4)test3(4)
          4 format("pid ",i8," send_off array wrong size ",i8)
          			write(err_str2,*)"should be ",numnodes
            		tmp=.false.
            	endif
            endif
            if(tmp)then
            	if(test3(5) .ne. test3(7))then
            		write(err_str1,5)test3(5),test3(7)
          5 format("pid ",i8," sum(to_send) ",i8," .ne. size(xin) ",i8)
          			write(err_str2,*)"should be the same"
            		tmp=.false.
            	endif
            endif
            if(tmp)then
            	if(test3(6) .ne. test3(8))then
            		write(err_str1,6)test3(6),test3(8)
          6 format("pid ",i8," sum(to_get) ",i8," .ne. size(xout) ",i8)
          			write(err_str2,*)"should be the same"
            		tmp=.false.
            	endif
            endif
			call ccm_alltoall(tosend,toget)
			if(tmp)then
				do i=0,min(test3(1),test3(2))-1
					if(toget(i).ne.test2(i+1))then
						tmp=.false.
						write(err_str1,*)"mismatch between number being received and sent"
						write(err_str2,2)myid,toget(i),test2(i+1)
          2 format("pid ",i8," sending, pid ",i8," getting",i8)
						exit
					endif
				enddo
			endif
            call ccm_allreduce(tmp,passed,"and")
		case ("allreduce")
			dummy4(1:8)=test1(1:8)
			call ccm_bcast(dummy4)
			dummy=0
!			do i=1,8
!				if(dummy4(i) .ne. test2(i) .or. test1(i) .ne. test2(i))dummy=1
!			enddo
			if(product(dummy4(1:8),mask=dummy4 .ne. 0) .ne. product(test1(1:8),mask=test1 .ne. 0))dummy=1
			if(product(test2(1:8),mask=test2 .ne. 0)  .ne. product(test1(1:8),mask=test1 .ne. 0))dummy=1
			tosend=0
			call ccm_gather(dummy,tosend)
			if(myid .eq. 0)then
				if(sum(tosend) .gt. 0)tmp=.false.
			endif
			call ccm_bcast(tmp)
			passed=tmp
			if(.not. passed)then
				write(err_str1,*)"shape of input array: ",test1," shape of output array: ",test2
				write(err_str2,*)"sizes should be the same on all processors"
			endif
		case ("reduce")
			dummy4(1:8)=test2(1:8)
			call ccm_bcast(dummy4,root=root)
			dummy=0
!			do i=1,8
!				if(dummy4(i) .ne. test1(i))dummy=1
!			enddo
			if(product(dummy4(1:8),mask=dummy4 .ne. 0) .ne. product(test1(1:8),mask=test1 .ne. 0))dummy=1
			tosend=0
			call ccm_gather(dummy,tosend)
			if(myid .eq. 0)then
				if(sum(tosend) .gt. 0)tmp=.false.
			endif
			call ccm_bcast(tmp)
			passed=tmp
			if(.not. passed)then
				if(myid .eq. root)then
				write(err_str1,*)"shape of input array: ",test1," shape of output array: ",test2
				else
				write(err_str1,*)"shape of input array: ",test1
				endif
				write(err_str2,*)"sizes should be the same arcoss all processors"
			endif
		case default
	end select
	call ccm_testing(set_test=old_test)
	end subroutine
		
			
			
			
			
			
           
		
