module ccm_numz
! basic real types
    integer, parameter:: b8 = selected_real_kind(10)
    integer, parameter:: b4 = selected_real_kind(5)
    integer, parameter:: c8 = selected_real_kind(10)
    integer, parameter:: c4 = selected_real_kind(5) 
!    integer, parameter:: b8 = selected_real_kind(20)
!    integer, parameter:: b4 = selected_real_kind(10)
!    integer, parameter:: c8 = selected_real_kind(20)
!    integer, parameter:: c4 = selected_real_kind(10)
    integer, parameter:: b16= selected_real_kind(20) 
    integer, parameter:: c16= selected_real_kind(20) 
    integer, parameter:: alt_int = selected_int_kind(16) 
    integer, parameter:: def_int = kind(iccm_dummy_int)
! other values used by the api
    include "mpif.h"
    integer mpi_err
    integer, parameter::MPI_ROOT=0
    integer, parameter::MPI_ZERO=0
    integer,save :: myreal,mydouble
    integer,save :: mycomp,mydpcomp
    integer,save :: myqp,myqpcomp
    integer,save :: myint,mycharacter,mylogical,mylong
    integer,save :: mycomm,myid,numnodes
    integer :: do_tests,test_ray1(8),test_ray2(8),test_ray3(8)
    logical :: passed_test
! public values for the API
    integer, parameter :: ccm_alloff=0
    integer, parameter :: ccm_checksize=1
    integer, parameter :: ccm_deadlock=2
    integer, parameter :: ccm_trace=4
    integer, parameter :: ccm_internal=8
    integer, parameter :: ccm_reproducible=0
    integer, parameter :: ccm_fast=1
    character (len=12) :: ccm_name
    logical,save :: ccm_auto_print
    real,save :: ccm_timeout
! error information
    character(len=128),save:: err_str0,err_str1,err_str2,err_str3,err_str4
! machine specific values
    integer :: ccm_iounits(1) = (/0/)
! if force_four is true then we will define
! our mpi_real in term of mpi_character
    logical, parameter :: force_four= .true.
    integer :: ccm_start_time(8)
	interface
		subroutine ccm_check_sizes(routine,test1,test2,test3,root,passed)
			character(len=*) :: routine
			integer :: test1(:),test2(:),test3(:)
			integer :: root
			logical :: passed
		end subroutine
	end interface

 contains
     function ccm_time()
        implicit none
        real(b8) :: ccm_time,tmp
        integer,parameter :: norm(13)=(/  &   
               0, 2678400, 5097600, 7776000,10368000,13046400,&
        15638400,18316800,20995200,23587200,26265600,28857600,31536000/)
        integer,parameter :: leap(13)=(/  &   
               0, 2678400, 5184000, 7862400,10454400,13132800,&
        15724800,18403200,21081600,23673600,26352000,28944000,31622400/)
        integer :: values(8),m,sec
        call date_and_time(values=values)
        if(mod(values(1),4) .eq. 0)then
           m=leap(values(2))
        else
           m=norm(values(2))
        endif
        sec=((values(3)*24+values(5))*60+values(6))*60+values(7)
        tmp=real(m,b8)+real(sec,b8)+real(values(8),b8)/1000.0_b8
        !write(*,*)"vals ",values
        if(values(1) .ne. ccm_start_time(1))then
            if(mod(ccm_start_time(1),4) .eq. 0)then
                tmp=tmp+real(leap(13),b8)
            else
                tmp=tmp+real(norm(13),b8)
            endif
        endif
        ccm_time=tmp
    end function
    subroutine ccm_testing(get_test,set_test)
        implicit none
        integer,optional :: get_test,set_test
        if(present(get_test))get_test=do_tests
        if(present(set_test))do_tests=set_test
    end subroutine

end module

